<script lang="ts">
	import type { OrderStatusInterface } from "./OrderStatus";

	export let status: OrderStatusInterface = null;

	const displayStatusIcon = (isInstallable: boolean, reasons: string[]) => {
		if (!isInstallable && !reasons.length) {
			return "";
		}

		const color = isInstallable ? "text-success" : "";
		const icon = isInstallable ? "fa-solid fa-square-check" : "fa-solid fa-screwdriver-wrench";

		return `<span class="align-middle ${color}"><i class="${icon}" /></span>`;
	}

	const displayReasons = (isInstallable: boolean, reasons: string[]) => {
		if (isInstallable) {
			return `<div>
				<p class="alert alert-success">
					🎉All prerequisites are fullfilled and your server is in the setup queue.
					<br />
					You will get an email once it's ready, keep an eye on your inbox!
				</p>
			</div>`
		}

		if (!isInstallable && !reasons.length) {
			return `<div>
				<p class="alert alert-info">Uh-oh, there is no such server in the setup queue, it was either already installed or the link you opened is invalid.
					<br />
					In either case, check your inbox for the details! If you can't find the email, please <a href="/contacts">contact us</a>.
				</p>
			</div>`
		}

		if (!isInstallable && reasons.length) {
			let errorsLists = "";
			reasons.forEach(reason => errorsLists += "<li>" + reason + "</li>")

			return `<div>
				<p class="alert alert-warning">
					Unfortunately, some prerequisites are not fulfilled, and thus your server cannot be installed just yet.
				</p>
				<p>Please, address the issues below:</p>
				<ul class="">
					${errorsLists}
				</ul>
				<p>If you need assistance, please read the FAQ below. If you can't find the answer in the FAQ, please <a href="/contacts">contact us</a>.</p>
			</div>`
		}
	}
</script>
{#if status !== null}
	<div class="d-flex mt-5 flex-column align-center">
		<div class="text-center">
			<h2 class="d-inline-block m-0">{status.domain} {@html displayStatusIcon(status.installable, status.reasons)}</h2>
		</div>
		<hr />
		{@html displayReasons(status.installable, status.reasons)}
	</div>
{/if}
